package com.maroontress.madangler.client;

import com.google.gwt.xml.client.Attr;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NamedNodeMap;
import com.google.gwt.xml.client.XMLParser;
import java.util.HashMap;

/**
   󥯤ɽ饹Ǥ

   ɽƤ륵֥ѥͥȤ֤XMLǤ˥ꥢ饤
   ꡢεդ򤹤뤿˻Ѥޤѿ̾typeϥ֥ѥͥꤹ
   ˻Ѥޤʳѿϥ֥ѥͥ˰¸ޤ
*/
public class Link {

    /** ѿ̾ͤΥޥå */
    private HashMap<String, String> propertyMap;

    /**
       Υ󥯤ޤ
    */
    public Link() {
        propertyMap = new HashMap<String, String>();
    }

    /**
       ֥ѥͥ򼨤󥯤ޤ

       @param type ֥ѥͥ򼨤ʸ
    */
    public Link(final String type) {
        propertyMap = new HashMap<String, String>();
	propertyMap.put("type", type);
    }

    /**
       ѿɲäޤ

       ǤƱ̾ѿ¸ߤϾ񤭤ޤvaluenullΤ
       ѿޤ

       @param key ѿ̾
       @param value 
    */
    public void addParameter(final String key, final String value) {
	if (value == null) {
	    propertyMap.remove(key);
	    return;
	}
	propertyMap.put(key, value);
    }

    /**
       ѿͤޤ

       @param key ѿ̾
       @return 
    */
    public String getParameter(final String key) {
	return propertyMap.get(key);
    }

    /**
       󥯤XMLǤ˥ꥢ饤ޤ

       @return XMLΥ
    */
    public String encode() {
	Document d = XMLParser.createDocument();
	Element root = d.createElement("link");

	String[] key = propertyMap.keySet().toArray(new String[0]);
	for (int k = 0; k < key.length; ++k) {
	    String name = key[k];
	    String value = propertyMap.get(name);
	    root.setAttribute(name, value);
	}
	d.appendChild(root);
	return d.toString();
    }

    /**
       ʸǥꥢ饤ƥ󥯤ޤ

       @param token XMLΥ
       @return 
    */
    public static Link decode(final String token) {
	Link link = new Link();
	try {
	    Document d = XMLParser.parse(token);
	    Element elem = d.getDocumentElement();
	    if (!elem.getTagName().equals("link")) {
		return null;
	    }
	    NamedNodeMap map = elem.getAttributes();
	    for (int k = 0; k < map.getLength(); ++k) {
		Attr attr = (Attr) map.item(k);
		link.addParameter(attr.getName(), attr.getValue());
	    }
	} catch (DOMException e) {
	    return null;
        }
	return link;
    }
}
