package com.maroontress.madangler.client.request;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;

/**
   CGIꥯȤ뤿εǽ󶡤ޤ
*/
public class RequestKit implements RequestCallback {

    /** HTTPꥯȥӥ */
    private RequestBuilder builder;

    /** ꥯȥꥹ */
    private RequestListener listener;

    /** ꥯ */
    private Request request;

    /**
       ꥯȥåȤޤ
    */
    public RequestKit() {
	builder = new RequestBuilder(RequestBuilder.POST, "shell.cgi");
	builder.setHeader("Content-Type", "application/x-www-form-urlencoded");
    }

    /**
       ꥯȤޤ

       @param uri ꥯURI
       @param listener ꥯȥꥹ
    */
    public void sendRequest(final String uri, final RequestListener listener) {
	this.listener = listener;
	listener.startRequest();
	try {
	    request = builder.sendRequest(uri, this);
	} catch (RequestException e) {
	    listener.stopRequest();
	    listener.errorThrown(null, e);
	}
    }

    /**
       ꥯȤ򥭥󥻥뤷ޤ
    */
    public void cancel() {
	if (request == null) {
	    return;
	}
	request.cancel();
    }

    /**
       顼ȯȤ˸ƤӽФޤ

       @param req ꥯ
       @param e Ȥʤä㳰
    */
    public void onError(final Request req, final Throwable e) {
	listener.stopRequest();
	listener.errorThrown(req, e);
    }

    /**
       쥹ݥ󥹤ǤȤ˸ƤӽФޤ

       @param req ꥯ
       @param res 쥹ݥ
    */
    public void onResponseReceived(final Request req, final Response res) {
	listener.stopRequest();
	listener.responseReceived(req, res);
    }
}
